---
title: String.prototype.search()
slug: Web/JavaScript/Reference/Global_Objects/String/search
tags:
  - JavaScript
  - Method
  - Prototype
  - Reference
  - Regular Expressions
  - String
---
<div>{{JSRef}}</div>

<p>The <strong><code>search()</code></strong> method executes a search for a match between a regular expression and this {{jsxref("String")}} object.</p>

<div>{{EmbedInteractiveExample("pages/js/string-search.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>str</var>.search(<var>regexp</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>regexp</var></code></dt>
 <dd>A <a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">regular expression</a> object.</dd>
 <dd>If a non-RegExp object <code><var>regexp</var></code> is passed, it is implicitly converted to a {{jsxref("RegExp")}} with <code>new RegExp(<var>regexp</var>)</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The index of the first match between the regular expression and the given string, or <code>-1</code> if no match was found.</p>

<h2 id="Description">Description</h2>

<p>When you want to know whether a pattern is found, and <em>also</em> know its index within a string, use <code>search()</code>. (If you only want to know if it exists, use the similar {{jsxref("RegExp.prototype.test()", "test()")}} method on the <code>RegExp</code> prototype, which returns a boolean.)</p>

<p>For more information (but slower execution) use {{jsxref("String.prototype.match()", "match()")}} (similar to the regular expression {{jsxref("RegExp.prototype.exec()", "exec()")}} method).</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_search">Using search()</h3>

<p>The following example searches a string with two different regex objects to show a successful search (positive value) vs. an unsuccessful search (<code>-1</code>)</p>

<pre class="brush: js notranslate">let str = "hey JudE"
let re = /[A-Z]/g
let reDot = /[.]/g
console.log(str.search(re))    // returns 4, which is the index of the first capital letter "J"
console.log(str.search(reDot)) // returns -1 cannot find '.' dot punctuation</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-string.prototype.search', 'String.prototype.search')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.String.search")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Regular_Expressions">Using regular expressions in JavaScript</a></li>
 <li>{{jsxref("String.prototype.match()")}}</li>
 <li>{{jsxref("RegExp.prototype.exec()")}}</li>
</ul>
